% lab07_ex_butterworth.m - design of analog Butterworth filters
clear all; close all;

N=6;                                % number of poles
f0 = 100;                           % 3 dB cut-off frequency
w0 = 2*pi*f0;                       % radial frequency, pulsation
dfi = pi/N;                         % angle of ``piece of cake''
fi = pi/2 + dfi/2 + (0 : N-1)*dfi;  % all angles of poles
p = w0*exp(j*fi);                   % all poles
if(0)                               % LOW-PASS
  z = [];                           % no zeros
  gain = real( prod(-p) );          % gain
else                                % HIGH-PASS
  z = zeros(1,N);                   % zeros
  gain = 1;                         % gain
end  
a = poly(p);                  % poles to coeffs of polynomial of denominator A(z)
b = poly(z);                  % poles to coeffs of polynomial of nominator B(z)
f = 0:1:1000;                 % frequencies of interest
w = 2*pi*f;                   % radial frequencies
s = j*w;                      % Laplace transform ``s'' variavle
H = gain*polyval(b,s) ./ polyval(a,s);               % ratio of two polynomials
ang=0:pi/100:2*pi; co=w0*cos(ang); si=w0*sin(ang);   % circle for poles 
figure; plot(real(z),imag(z),'bo',real(p),imag(p),'r*',co,si,'k-'); title('ZP'); pause
figure; plot(f,20*log10(abs(H))); grid; xlabel('f [Hz]'); title('|H(f)| (dB)'); pause
figure; semilogx(f(2:end),20*log10(abs(H(2:end)))); grid; xlabel('f [Hz]'); title('|H(f)| (dB)'); pause
