% lab07_ex_lti.m - linear time-invariant analog systems
clear all; close all;

b = [1, 2];         % coefficients {b} of the TF nominator   polynomial 
a = [3, 4, 5];      % coefficients {a} of the TF denominator polynomial 
f = 0 : 0.01 : 10;  % frequencies of interest  
t = 0 : 0.01 : 10;  % time of interest
f0 = 1;             % radius (w0=2*pi*f0) for circle in s=j*w domain
[ H, h ] = AFigs(b,a,f,t,1); % figures for analog filter

% ################################
function [H,h] = AFigs(b,a,f,t,f0)

% Position of transfer function zeros and poles
z = roots(b)/(2*pi); p = roots(a)/(2*pi);  % scaling for frequency
phi = 0:pi/1000:2*pi; si  = f0*sin(phi); co = f0*cos(phi);
figure; plot(real(z),imag(z),'ro',real(p),imag(p),'b*',co,si,'k-'); 
xlabel('real()'); xlabel('imag()'); title('TF Zeros & Poles'); grid; pause

% Frequency response
w = 2*pi*f; s = j*w;            % radial frequency, Laplace transform variable 
H = polyval(b,s)./polyval(a,s); % frequency response H(f) = H(s=j*2*pi*f)
% H = freqs(b,a,2*pi*f);        % Matlab function
% Figures
figure; plot(f,abs(H)); xlabel('f (Hz)'); title('|H(f)|'); grid; pause
figure; plot(f,20*log10(abs(H))); xlabel('f (Hz)'); title('|H(f)| (dB)'); grid; pause
figure; semilogx(f,20*log10(abs(H))); xlabel('f (Hz)'); title('|H(f)| (dB)'); grid; pause
figure; plot(f,angle(H)); xlabel('f (Hz)'); title('\angle H(f) (rd)'); grid; pause

% Impulse response
figure
subplot(211); impulse(b,a),      % plot impulse response h(t)
subplot(212); step(b,a), pause   % plot step response u(t); test also: 
h = impulse(b,a,t);              % calculate impulse response h(t)  
figure; plot(t,h); grid; xlabel('t (s)'); title('Impulse response h(t)'); pause
u = step(b,a,t);                 % calculate step response u(t) 
figure; plot(t,u); grid; xlabel('t (s)'); title('Step response u(t)'); pause   

end