% lab07_ex_zp_design.m
% In Octave first load control toolbox (package): >>pkg load control[ENTER]
% For functions: impulse(), step()
clear all; close all;

task = 1;   % 1=Remove/Amplify, 2=LP, 3=BP
if(task==1) % Simple ZP design: remove 3000, 4000 Hz, amplify 100, 1000, 2000 Hz
   z = j*2*pi*[ 3000 4000 ];                       z = [ z conj(z) ]; 
   p = [ -10 -10 -10 ] + j*2*pi*[ 100 1000 2000 ]; p = [ p conj(p) ]; 
   b = poly(z);  a = poly(p);
   b = 100*b / abs(polyval( b,j*2*pi*2000) / polyval( a,j*2*pi*2000) );
end
% Design filter rejecting 1500 Hz and amplifying 3000 Hz.

%###############################            
if(task==2) % ZP design of LowPass filter [ 0 - 1000 Hz ]
   z = j*2*pi*[ 2000 3000  ];                            z = [ z conj(z) ];
   p = [ -2000 -2000 -400 ] + j*2*pi*[ 400 700 1000 ];   p = [ p conj(p) ];
   b = poly(z);  a = poly(p);
   b = b / abs(polyval( b,0) / polyval( a,0) );
end
% Using ZP method design a good analog HighPass filter for [ 2000 ... ] Hz.

%###############################            
if(task==3) % ZP design of BandPass [ 1000 Hz - 2000 Hz ]
   z = j*2*pi*[ 250 500  2500 2750  ];
   z = [ z conj(z) ];
   p = [ -450 -2000 -3500 -2000 -400 ] + j*2*pi*[ 1000 1250 1500 1750 2000 ];
   p = [ p conj(p) ];
   b = poly(z);  a = poly(p);
   b = b / abs(polyval( b,j*2*pi*1500) / polyval( a,j*2*pi*1500) );
end

% Figures
f = 0 : 1 : 10000;           % frequencies of interest  
t = 0 : 1e-5 : 50e-3;        % time of interest
f0 = 1000;                   % radius (w0=2*pi*f0) for circle in s=j*w domain
[ H, h ] = AFigs(b,a,f,t,1); % figures for analog filter
